"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Node = void 0;
var Node = /** @class */ (function () {
    function Node(path, gun) {
        this.path = path;
        this.gun = gun;
        var p = path.split('.');
        this.ref = p.reduce(function (previous, key) { return previous.get(key); }, gun);
    }
    Node.prototype.encode = function (data) {
        if (!data || typeof data !== 'object')
            return data;
        return Object.keys(data).reduce(function (obj, key) {
            if (Array.isArray(data[key])) {
                obj["[]" + key] = JSON.stringify(data[key]);
            }
            return obj;
        }, {});
    };
    Node.prototype.decode = function (data) {
        if (!data || typeof data !== 'object')
            return data;
        return Object.keys(data).reduce(function (obj, key) {
            if (key.startsWith('[]')) {
                obj[key.slice(2)] = JSON.parse(data[key]);
            }
            return obj;
        }, {});
    };
    Object.defineProperty(Node.prototype, "parent", {
        get: function () {
            var p = this.path.split('.');
            var path = p.slice(0, p.length - 1).join('.');
            console.log(p, path);
            return new Node(path, this.gun);
        },
        enumerable: false,
        configurable: true
    });
    Node.prototype.set = function (value, anonymous) {
        if (anonymous === void 0) { anonymous = false; }
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.ref.put({ $data: _this.encode(value) }, function (_a) {
                            var err = _a.err, ok = _a.ok;
                            if (err !== undefined)
                                return reject(err);
                            resolve(ok);
                        });
                    })];
            });
        });
    };
    Node.prototype.on = function (listener) {
        var _this = this;
        this.ref.on(function (value) {
            if (value.$data !== undefined) {
                listener(_this.decode(value.$data));
            }
        });
    };
    Node.prototype.get = function (timeout) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var timeoutInstance;
            if (timeout) {
                timeoutInstance = setTimeout(function () { return reject(new Error("get " + _this.path + " timeout")); }, timeout);
            }
            _this.ref.once(function (value) {
                if (!value)
                    return resolve(null);
                if (value.$data) {
                    if (timeoutInstance) {
                        clearTimeout(timeoutInstance);
                    }
                    resolve(_this.decode(value.$data));
                }
            }, timeout ? { wait: timeout } : undefined);
        });
    };
    return Node;
}());
exports.Node = Node;
//# sourceMappingURL=node.js.map